COMMENT~
This source code is free, but if you use it for something else I'd appreciate
it if you'd put me in the credits somewhere...

       *** clr_table ***
 the table of colors in this order:
 -./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ

       *** format of clr_table ***
 format of color is: ANSI fore[0-7] + (ANSI back[0-7] * 16)
 add 128 for blink
 add 8 for hi intensity

       *** security level codes ***
 with VBBS, there are these codes, starting on the first character of a line,
 and they specify what security level is needed to display this line, i.e:
 !255            rest of line
 if you don't use VBBS, don't worry...

 send comments, etc to
 Ryan Press #1 (14.4k BBS: 707-277-9656)
 MicroNet: 1 @7718
 NorthBayNet: Ryan Press @357:200/1
 EclecticNet: Ryan Press @77:222/1

~
; *** Macros ***

@exit_interrupt MACRO
	mov     al,20h
	out     20h,al
	iret
		ENDM
@new_stak       MACRO				; setup new stack
	cli
	mov	cs:OLD_STAK_ss,ss
	mov     cs:OLD_STAK_sp,sp
	push	cs
	pop	ss
	mov     sp,offset cs:STAK
	sti
		ENDM
@restore_stak   MACRO				; restore old one
	cli
	mov     ss,cs:OLD_STAK_ss
	mov	sp,cs:OLD_STAK_sp
	sti
		ENDM

CODE    segment para public 'CODE'
	assume  cs:CODE
	org     2Ch
environment_seg LABEL   WORD
	org     80h
cmd_line_len    LABEL   BYTE
	org     81h
cmd_line        LABEL   BYTE
	org     100h
ENTRY:  jmp     INIT

STAK            LABEL   BYTE			; use part of command line
						; for stack
OLD_STAK_sp     dw  ?				; stack save variables
OLD_STAK_ss	dw  ?
OLDINT29_VEC    dd  ?				; interrupt save variables
OLDINT2F_VEC    dd  ?
next_sec_num    db  0
next_heart_code db  0

first_rw        equ 'A2'                        ; special recognition codes
second_rw       equ 'MN'

clr_table1      db  8,0,0,7,14,11,5,79,10,9,12,3,6,2,13,31,27,28,23,44,57,60,75
		db  78,71,95,96,112,113,116,127,121,124,15,16,64,80,47,111
clr_table2      db  0,0,0,7,14,11,5,79,10,137,12,4,1

is_wwiv         db  0FFh			; if 1, then WWIV colors
show_sec        db  0FFh			; if 0, then hide security
last_char       db  0				; last character in int29
mul_proc_num    db  ?				; multiplex number


INT2F   proc    far                             ; multiplex interrupt
	assume	cs:CODE
	@new_stak
	cli
	cmp     ah,mul_proc_num                 ; if ah isn't MNUANSI's ah,
	jne     continue_mul                    ; continue on
	cmp     al,0                            ; if requesting installation
	je      mul_inst_check                  ; status, go there
	cmp     al,1                            ; if changing wwiv status
	je      change_vars                     ; go change them
	cmp     al,2				; if unloading TSR
	je      unload_tsr			; go unload it
	jmp     continue_mul                    ; continue on
change_vars:
	cmp     bl,0FFh				; if bl is valid..
	je      no_change_wwiv_bool
	mov     is_wwiv,bl                      ; bl should be a 1 or 0
no_change_wwiv_bool:
	cmp     bh,0FFh				; if bh is valid..
	je      no_change_sec_bool
	mov     show_sec,bh			; bh should be a 1 or 0
no_change_sec_bool:
	jmp     continue_mul                    ; continue on
mul_inst_check:
	mov     al,0FFh                         ; return FFh, installed
	mov     bx,first_rw                     ; also, return install check
	mov     cx,second_rw                    ; registers
continue_mul:
	@restore_stak
	jmp     OLDINT2F_VEC                    ; jmp to old vec
unload_tsr:
	push    ax es                           ; get address of old int 29h
	mov     ax,0
	mov     es,ax
	mov     bx,es:[29h*4]
	mov     cx,es:[29h*4+2]
	mov     dx,cs
	cmp     cx,dx                           ; and compare it to the
	jnz     bad_unload                      ; current one
	cmp     bx,offset cs:INT29
	jnz     bad_unload
	mov     bx,es:[2Fh*4]                   ; get adderss of old int 2Fh
	mov     cx,es:[2Fh*4+2]
	mov     dx,cs
	cmp     cx,dx                           ; and compare it to the
	jnz     bad_unload                      ; current one
	cmp     bx,offset cs:INT2F
	jnz     bad_unload
	jmp     continue_unload
bad_unload:
	pop     es ax				; bad unload, go back to caller
	mov     al,1
	jmp     continue_mul
continue_unload:
	push    dx ds
	sti
	mov     ax,0
	mov     es,ax
	mov     ax,word ptr OLDINT29_VEC        ; replace old interrupts
	mov     es:[29h*4],ax
	mov     ax,word ptr OLDINT29_VEC+2
	mov     es:[29h*4+2],ax
	mov     ax,word ptr OLDINT2F_VEC
	mov     es:[2Fh*4],ax
	mov     ax,word ptr OLDINT2F_VEC+2
	mov     es:[2Fh*4+2],ax
	push    cs
	pop     es
	mov     ah,049h                         ; de-allocate TSR memory
	int     21h
	cli
	pop     ds dx es ax
	mov     al,0				; good unload
	jmp     continue_mul
INT2F   endp

INT29   proc    far
	assume  cs:CODE,ds:nothing,es:nothing
	cmp     next_sec_num,1                  ; eat up security level codes
	je      get_sec
	cmp     next_heart_code,1               ; jmp to color change if
	je      change_color                    ; last char was a heart
	cmp     al,''                          ; jmp to heart processing fn
	je      proc_heart                      ; if this char is a ''
	cmp     al,'!'                          ; if this char is a '!'
	je      proc_sec
continue_int29:
	mov     last_char,al
	sti
	jmp     OLDINT29_VEC                    ; call old INT29
exit_int29:
	@exit_interrupt
proc_sec:
	cmp     show_sec,1                      ; show security?
	je      continue_int29                  ; yep, so continue on
	cmp     last_char,10                    ; is it a FF?
	je      c_proc_sec                      ; yep, so go process it
	cmp     last_char,13                    ; is it a CR?
	jne     continue_int29                  ; continue on if not
c_proc_sec:
	mov     next_sec_num,1                  ; ok, process next character
	jmp	exit_int29
proc_heart:
	mov     next_heart_code,1               ; setup var to process color
	jmp	exit_int29
get_sec:
	cmp     al,'0'                          ; if < 0 or > 9 then exit
	jl      not_sec
	cmp     al,'9'
	jg      not_sec
	jmp	exit_int29
not_sec:
	mov     next_sec_num,0                  ; quit processing security
	jmp     continue_int29                  ; continue on
change_color:
	@new_stak
	push	ax bx cx dx
	mov     next_heart_code,0               ; clear var
	cmp     al,'-'                          ; make sure al > '0'
	jl      @end_clr
	cmp     al,'9'                          ; jmp to @number if al < '9'
	jl      @number
	cmp     al,'A'                          ; make sure al > 'A'
	jl      @end_clr
	cmp     al,'Z'                          ; make sure al < 'Z'
	jg      @end_clr

	sub     al,'A'                          ; must be a letter, so
	add     al,13                           ; convert to number and add
	jmp     @start_proc                     ; 13
@end_clr:
	pop     dx cx bx ax                     ; restore regs
	@restore_stak				; restore stack
	@exit_interrupt				; exit
@number:
	sub     al,'-'                          ; convert letter to number
@start_proc:
	mov     ah,0                            ; get fore and back from table
	mov     bh,0
	mov     bl,al
	mov     al,is_wwiv
	cmp     al,1
	je      wwiv_table
	mov     al,byte ptr clr_table1[bx]
	jmp     no_wwiv_table
wwiv_table:
	mov     al,byte ptr clr_table2[bx]
no_wwiv_table:
	mov     cl,al
	mov     bl,16
	div     bl
	mov     dl,al                           ; dl is back
	mov     cl,ah                           ; cl is fore

	cmp     dl,7                            ; if > 127 it's blinking
	jg      blink
	mov     bl,0
	jmp     blink_end
blink:
	mov     bl,1
	sub     dl,8
blink_end:

	cmp     cl,7                            ; if > 7 it's HI intensity
	jg      hi_clr
	mov     bh,0                            ; convert to ANSI string
	mov     ch,'3'
	add     cl,'0'
	jmp     hi_clr_end
hi_clr:  
	mov     bh,1                            ; HI intensity
	mov     ch,'3'
	sub     cl,8
	add     cl,'0'
hi_clr_end:
	mov     dh,'4'                          ; background ANSI string
	add     dl,'0'

	mov     al,27                           ; escape characters
	int     29h
	mov     al,'['
	int     29h
	
	mov     al,'0'                          ; always go to normal intensity
	int     29h
	mov     al,';'
	int     29h

	cmp     bh,1                            ; if bh=1 it's HI intensity
	jne     end_high

	mov     al,'1'                          ; high(ansi '1;')
	int     29h
	mov     al,';'
	int     29h
end_high:
	cmp     bl,1
	je      @blink
	jmp     @end_blink
@blink:
	mov     al,'5'                          ; echo blinking 
	int     29h
	mov     al,';'
	int     29h
@end_blink:

	mov     al,ch                           ; echo fore color
	int     29h
	mov     al,cl
	int     29h

	mov     al,';'                          ; seperating semicolon
	int     29h

	mov     al,dh                           ; echo back color
	int     29h
	mov     al,dl
	int     29h

	mov     al,'m'                          ; end ESC sequence
	int     29h
	pop     dx cx bx ax                     ; restore regs
	@restore_stak				; restore stack
	@exit_interrupt				; exit
INT29   endp
 
END_TSR         LABEL BYTE                      ; Marks end of TSR data & code

uninstall       db  0
start_msg       db  13,10,'MNU-ANSI v2.5, by Ryan Press',13,10,13,10,'$'
vbbs_on         db  'VBBS mode enabled',13,10,'$'
wwiv_on         db  'WWIV mode enabled',13,10,'$'
sc_on           db  'Security levels shown.',13,10,'$'
sc_off          db  'Security levels hidden.',13,10,'$'
no_parms_msg    db  'You must specify WWIV or ANSI colors',13,10
		db  'Syntax: "MNUANSI <W | V>  |  {S | H}  |  U  |  ?"',13,10
		db  'W = WWIV, V = VBBS (must specify one)',13,10
		db  'S = show security codes, H = hide (optional)',13,10
		db  'U = unload',13,10
		db  '? = help',13,10,'$'
no_free_mul_msg db  'No free multiplex.',13,10,'$'
alrdy_inst_msg  db  'Already installed!',13,10,'$'
no_uninstall    db  'Uninstall failed!',13,10,'$'
uninstalled     db  'Uninstall complete.',13,10,'$'

INIT    proc
	assume  cs:CODE
	mov     ah,9                            ; show starting message
	mov     dx,offset start_msg
	int     21h
	call    get_cmd_line
	call    check_if_loaded                 ; check if already loaded
	jnc     not_loaded
	cmp     uninstall,1
	je      uninstall_it
	mov     al,1
	mov     bx,0FFFFh
	cmp     is_wwiv,0FFh
	je      no_call_wwiv
	mov     bl,is_wwiv                      ; new is_wwiv...
no_call_wwiv:        
	cmp     show_sec,0FFh
	je      no_call_sec
	mov     bh,show_sec
no_call_sec:
	int     2Fh
	mov     ah,9
	mov     dx,offset alrdy_inst_msg        ; echo already installed msg
	int     21h
	mov     ax,4C03h                        ; terminate w/ err level 3
	int     21h
uninstall_it:
	mov     al,2
	int     2Fh
	cmp     al,0
	jne     cant_unload
	mov     ah,9
	mov     dx,offset uninstalled
	int     21h
	mov     ax,4C00h
	int     21h
cant_unload:
	mov     ah,9
	mov     dx,offset no_uninstall
	int     21h
	mov     ax,4C04h
	int     21h
not_loaded:
	cmp     uninstall,1
	je      cant_unload
	cmp     is_wwiv,0FFh
	jne     good_parms
	mov     ah,9
	mov     dx,offset no_parms_msg
	int     21h
	mov     ax,4C01h
	int     21h
good_parms:
	call    find_mul
	jnc     found_a_mul
	mov     ah,9                            ; nope, none free!!!
	mov     dx,offset no_free_mul_msg
	int     21h
	mov     ax,4C02h                        ; terminate w/ err level 2
	int     21h
found_a_mul:
	cmp     show_sec,0FFh
	jne     good_sec
	mov     show_sec,1
good_sec:
	push    es
	mov     ax,0
	mov     es,ax
	mov     ax,es:[29h*4]
	mov     word ptr OLDINT29_VEC,ax        ; get old vectors
	mov     ax,es:[29h*4+2]
	mov     word ptr OLDINT29_VEC+2,ax
	mov     ax,es:[2Fh*4]
	mov     word ptr OLDINT2F_VEC,ax
	mov     ax,es:[2Fh*4+2]
	mov     word ptr OLDINT2F_VEC+2,ax

	cli
	mov     ax,offset INT29         ; set new vectors
	mov     es:[29h*4],ax
	mov     es:[29h*4+2],cs
	mov     ax,offset INT2F
	mov     es:[2Fh*4],ax
	mov     es:[2Fh*4+2],cs
	sti
	pop     es
	mov     es,cs:environment_seg           ; release environment block
	mov     ah,049h
	int     21h
	mov     ax,3100h
	mov     dx,offset END_TSR
	shr     dx,1
	shr     dx,1
	shr     dx,1
	shr     dx,1
	inc     dx
	int     21h                             ; Terminate and Stay Resident
INIT    endp

get_cmd_line    proc        
	mov     si,offset cmd_line              ; process comand line
	mov     bx,0
r_cmd_loop:
	lodsb
	cmp     bl,cmd_line_len
	je      end_cmd_line
	inc     bx
	cmp     al,'Z'
	jl      uppercase
	sub     al,32
uppercase:
	cmp     al,'W'
	je      parm_wwiv
	cmp     al,'V'
	je      parm_vbbs
	cmp     al,'S'
	je      parm_sc_on
	cmp     al,'H'
	je      parm_sc_off
	cmp     al,'U'
	je      set_uninstall_flag
	cmp     al,'?'
	je      show_parms
	jmp     r_cmd_loop
end_cmd_line:
	ret
set_uninstall_flag:
	mov     uninstall,1
	ret
parm_wwiv:
	mov     is_wwiv,1                       ; enable WWIV
	push    ax bx si
	mov     ah,9
	mov     dx,offset wwiv_on
	int     21h
	pop     si bx ax
	jmp     r_cmd_loop
parm_vbbs:
	mov     is_wwiv,0                       ; enable VBBS
	push    ax bx si
	mov     ah,9
	mov     dx,offset vbbs_on
	int     21h
	pop     si bx ax
	jmp     r_cmd_loop
parm_sc_on:
	mov     show_sec,1                      ; change security boolean on
	push    ax bx si
	mov     ah,9
	mov     dx,offset sc_on
	int     21h
	pop     si bx ax
	jmp     r_cmd_loop
parm_sc_off:
	mov     show_sec,0                      ; and off
	push    ax bx si
	mov     ah,9
	mov     dx,offset sc_off
	int     21h
	pop     si bx ax
	jmp     r_cmd_loop
show_parms:
	mov     ah,9
	mov     dx,offset no_parms_msg
	int     21h
	mov     ax,4C00h
	int     21h
get_cmd_line    endp
	
check_if_loaded proc
	mov     ax,0C000h
find_old_mul_loop:                              ; see if already loaded
	push    ax
	int     2Fh
	cmp     bx,first_rw
	jne     not_this_mul
	cmp     cx,second_rw
	je      found_old_mul
not_this_mul:
	pop     ax
	cmp     ah,0FFh                         ; done? not installed...
	je      not_installed
	inc     ax
	jmp     find_old_mul_loop               ; loop back up there
found_old_mul:
	pop     ax
	stc
	ret
not_installed:
	clc
	ret
check_if_loaded endp

find_mul        proc
	mov     ax,0C000h                       ; find a unused multiplex...
find_mul_loop:  
	push    ax
	int     2Fh
	cmp     al,0FFh
	jne     unused_mul
	pop     ax
	cmp     ah,0FFh
	je      no_free_mul
	inc     ax
	jmp     find_mul_loop
no_free_mul:
	stc
	ret
unused_mul:
	pop     ax                              ; ok, found one...
	mov     mul_proc_num,ah
	clc
	ret
find_mul        endp

CODE    ends
end     ENTRY
